import { Component, Directive, TemplateRef, Input, EventEmitter, ContentChildren, Output, ViewChild, NgModule } from '@angular/core';
import { __assign } from 'tslib';
import { map } from 'rxjs/operators';
import { Router, ActivatedRoute, RouterModule } from '@angular/router';
import { Location, CommonModule } from '@angular/common';
import { MatPaginator, MatPaginatorModule } from '@angular/material/paginator';
import { MatSort, MatSortModule } from '@angular/material/sort';
import { trigger, state, style, transition, animate } from '@angular/animations';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatIconModule } from '@angular/material/icon';
import { MatButtonModule } from '@angular/material/button';
import { MatTableModule } from '@angular/material/table';
import { MatCardModule } from '@angular/material/card';
import { MatFormFieldModule } from '@angular/material/form-field';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LayoutComponent = /** @class */ (function () {
    function LayoutComponent() {
    }
    /**
     * @return {?}
     */
    LayoutComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    LayoutComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-layout',
                    template: "\n    <p>\n      layout works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    LayoutComponent.ctorParameters = function () { return []; };
    return LayoutComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function RowColumn() { }
if (false) {
    /** @type {?} */
    RowColumn.prototype.columnId;
    /** @type {?} */
    RowColumn.prototype.columnName;
}
var TableRowColumnDirective = /** @class */ (function () {
    function TableRowColumnDirective(templateRef) {
        this.templateRef = templateRef;
    }
    TableRowColumnDirective.decorators = [
        { type: Directive, args: [{ selector: 'ng-template[rowColumn]' },] }
    ];
    /** @nocollapse */
    TableRowColumnDirective.ctorParameters = function () { return [
        { type: TemplateRef }
    ]; };
    TableRowColumnDirective.propDecorators = {
        rowColumn: [{ type: Input }]
    };
    return TableRowColumnDirective;
}());
if (false) {
    /** @type {?} */
    TableRowColumnDirective.prototype.rowColumn;
    /** @type {?} */
    TableRowColumnDirective.prototype.templateRef;
}
var TableContentComponent = /** @class */ (function () {
    function TableContentComponent(router, activatedRoute, location) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.location = location;
        this.hasToolbar = true;
        this.hasSearch = true;
        this.hasAddButton = true;
        this.hasBackButton = true;
        this.hasPaginator = true;
        this.tableRowClick = new EventEmitter();
    }
    Object.defineProperty(TableContentComponent.prototype, "tableLayoutInput", {
        get: /**
         * @return {?}
         */
        function () {
            return this._tableLayoutInput;
        },
        set: /**
         * @param {?} tl
         * @return {?}
         */
        function (tl) {
            this._tableLayoutInput = tl;
        },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(TableContentComponent.prototype, "matSort", {
        set: /**
         * @param {?} ms
         * @return {?}
         */
        function (ms) {
            this.sort = ms;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableContentComponent.prototype, "matPaginator", {
        set: /**
         * @param {?} ms
         * @return {?}
         */
        function (ms) {
            this.paginator = ms;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    TableContentComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.dataSource = this.tableLayoutInput.dataSource;
        this.dataSource.setPaginator(this.paginator);
        this.dataSource.setSort(this.sort);
        this.tableLayoutInput.columnDef.pipe(map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.columnId; })); }))).subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.displayedColumns = res;
        }));
        this.tableLayoutInput.columnDef.pipe(map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.columnName; })); }))).subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.columnNames = res;
        }));
        if (this.tableLayoutInput.addRoute) {
            this.addRoute = this.tableLayoutInput.addRoute;
        }
        if (this.tableLayoutInput.backRoute) {
            this.backRoute = this.tableLayoutInput.backRoute;
        }
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var columnMap = new Map();
        /** @type {?} */
        var refArray = this.rowColumnDirectives.toArray();
        refArray.forEach((/**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            columnMap.set(val.rowColumn, val);
        }));
        this.rowColumnTemplates = columnMap;
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.getPageSizeOptions = /**
     * @return {?}
     */
    function () {
        return [5, 10, 20, 50, 100, 250];
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.getDefaultPageSize = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var tableFilter = this.dataSource.filterSubject.value;
        if (tableFilter && tableFilter.pager) {
            return tableFilter.pager.pageSize;
        }
        return 250;
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.add = /**
     * @return {?}
     */
    function () {
        if (this.addRoute) {
            if (this.addRoute.queryParams) {
                this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
            }
            else {
                this.router.navigate([this.addRoute.path]);
            }
        }
        else {
            this.router.navigate(['0'], { relativeTo: this.activatedRoute });
        }
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.back = /**
     * @return {?}
     */
    function () {
        if (this.backRoute) {
            if (this.backRoute.queryParams) {
                this.router.navigate([this.backRoute.path], { queryParams: this.backRoute.queryParams });
            }
            else {
                this.router.navigate([this.backRoute.path]);
            }
        }
        else {
            this.location.back();
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    TableContentComponent.prototype.onRowClick = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        this.tableRowClick.emit(row);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    TableContentComponent.prototype.reload = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        filter = __assign({}, this.dataSource.filterSubject.value, filter);
        this.dataSource.filterSubject.next(filter);
        return false;
    };
    /**
     * @return {?}
     */
    TableContentComponent.prototype.navigateBack = /**
     * @return {?}
     */
    function () {
        this.location.back();
    };
    TableContentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-table-content',
                    template: "<mat-toolbar *ngIf=\"tableLayoutInput.title\" color=\"accent\" style=\"height:20px; opacity: 0.5\"><span\n  style=\"font-size: 0.7em\">{{tableLayoutInput?.title}}</span></mat-toolbar>\n<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" (click)='back()' class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container>   <!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix this -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<table #matTable mat-table [dataSource]=\"dataSource\" matSort\n       matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n       matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\">\n\n  <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n    <th mat-sort-header mat-header-cell *matHeaderCellDef>\n      {{columnNames[i]}}\n    </th>\n    <td mat-cell *matCellDef=\"let row\">\n      <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                    [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n    </td>\n  </ng-container>\n\n  <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\n  <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\" class=\"row-click\"></tr>\n</table>\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n  <!-- TODO extract loading indicator component to library <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n<!-- ===================================== Table empty ============================================================= -->\n<mat-card *ngIf=\"dataSource?.dataSubject?.value?.length === 0\" fxLayoutAlign=\"center\">\n  <span><!-- TODO should be configured as input prop -->Die Tabelle hat noch keine Eintr\u00E4ge!</span>\n</mat-card>\n\n<!-- ===================================== Table error ============================================================= -->\n<mat-card *ngIf=\"dataSource?.status === 'error'\" fxLayoutAlign=\"center\">\n  <mat-error><!-- TODO should be configured as input prop --> Es ist etwas falsch gelaufen</mat-error>\n</mat-card>\n"
                }] }
    ];
    /** @nocollapse */
    TableContentComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Location }
    ]; };
    TableContentComponent.propDecorators = {
        tableLayoutInput: [{ type: Input }],
        rowColumnDirectives: [{ type: ContentChildren, args: [TableRowColumnDirective,] }],
        hasToolbar: [{ type: Input }],
        hasSearch: [{ type: Input }],
        hasAddButton: [{ type: Input }],
        hasBackButton: [{ type: Input }],
        hasPaginator: [{ type: Input }],
        tableRowClick: [{ type: Output }],
        matSort: [{ type: ViewChild, args: [MatSort, { static: true },] }],
        matPaginator: [{ type: ViewChild, args: [MatPaginator, { static: true },] }]
    };
    return TableContentComponent;
}());
if (false) {
    /** @type {?} */
    TableContentComponent.prototype._tableLayoutInput;
    /** @type {?} */
    TableContentComponent.prototype.dataSource;
    /** @type {?} */
    TableContentComponent.prototype.rowColumnDirectives;
    /** @type {?} */
    TableContentComponent.prototype.rowColumnTemplates;
    /** @type {?} */
    TableContentComponent.prototype.hasToolbar;
    /** @type {?} */
    TableContentComponent.prototype.hasSearch;
    /** @type {?} */
    TableContentComponent.prototype.hasAddButton;
    /** @type {?} */
    TableContentComponent.prototype.hasBackButton;
    /** @type {?} */
    TableContentComponent.prototype.hasPaginator;
    /** @type {?} */
    TableContentComponent.prototype.tableRowClick;
    /** @type {?} */
    TableContentComponent.prototype.addRoute;
    /** @type {?} */
    TableContentComponent.prototype.backRoute;
    /**
     * @type {?}
     * @private
     */
    TableContentComponent.prototype.paginator;
    /**
     * @type {?}
     * @private
     */
    TableContentComponent.prototype.sort;
    /** @type {?} */
    TableContentComponent.prototype.displayedColumns;
    /** @type {?} */
    TableContentComponent.prototype.columnNames;
    /**
     * @type {?}
     * @private
     */
    TableContentComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    TableContentComponent.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    TableContentComponent.prototype.location;
    /* Skipping unhandled member: ;*/
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TableTitleComponent = /** @class */ (function () {
    function TableTitleComponent() {
    }
    /**
     * @return {?}
     */
    TableTitleComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TableTitleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-table-title',
                    template: "<p>\n  table-title works!\n</p>\n"
                }] }
    ];
    /** @nocollapse */
    TableTitleComponent.ctorParameters = function () { return []; };
    return TableTitleComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TableHeaderComponent = /** @class */ (function () {
    function TableHeaderComponent() {
    }
    /**
     * @return {?}
     */
    TableHeaderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TableHeaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-table-header',
                    template: "<mat-toolbar fxLayoutGap=\"10px\">\n  <ng-content></ng-content>\n  <div class=\"spacer\"></div>\n</mat-toolbar>\n"
                }] }
    ];
    /** @nocollapse */
    TableHeaderComponent.ctorParameters = function () { return []; };
    return TableHeaderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TableLayoutComponent = /** @class */ (function () {
    function TableLayoutComponent() {
        this.status = 'loading';
    }
    /**
     * @return {?}
     */
    TableLayoutComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TableLayoutComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-table-layout',
                    template: "<div class=\"table-layout mat-elevation-z12\">\n  <ng-content select=\"[content]\"></ng-content>\n</div>\n"
                }] }
    ];
    /** @nocollapse */
    TableLayoutComponent.ctorParameters = function () { return []; };
    TableLayoutComponent.propDecorators = {
        status: [{ type: Input }]
    };
    return TableLayoutComponent;
}());
if (false) {
    /** @type {?} */
    TableLayoutComponent.prototype.status;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function RowColumn$1() { }
if (false) {
    /** @type {?} */
    RowColumn$1.prototype.columnId;
    /** @type {?} */
    RowColumn$1.prototype.columnName;
}
var TableContentResponsiveComponent = /** @class */ (function () {
    function TableContentResponsiveComponent(router, activatedRoute, location) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.location = location;
        this.hasToolbar = true;
        this.hasSearch = true;
        this.hasAddButton = true;
        this.hasBackButton = true;
        this.hasPaginator = true;
        this.tableRowClick = new EventEmitter();
    }
    Object.defineProperty(TableContentResponsiveComponent.prototype, "tableLayoutInput", {
        get: /**
         * @return {?}
         */
        function () {
            return this._tableLayoutInput;
        },
        set: /**
         * @param {?} tl
         * @return {?}
         */
        function (tl) {
            this._tableLayoutInput = tl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableContentResponsiveComponent.prototype, "matSort", {
        set: /**
         * @param {?} ms
         * @return {?}
         */
        function (ms) {
            this.sort = ms;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TableContentResponsiveComponent.prototype, "matPaginator", {
        set: /**
         * @param {?} ms
         * @return {?}
         */
        function (ms) {
            this.paginator = ms;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.tableLayoutInput.dataSource.setPaginator(this.paginator);
        this.tableLayoutInput.dataSource.setSort(this.sort);
        this.tableLayoutInput.columnDef.pipe(map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.columnId; })); }))).subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.displayedColumns = res;
        }));
        this.tableLayoutInput.columnDef.pipe(map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res.columnName; })); }))).subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.columnNames = res;
        }));
        if (this.tableLayoutInput.addRoute) {
            this.addRoute = this.tableLayoutInput.addRoute;
        }
    };
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var columnMap = new Map();
        /** @type {?} */
        var refArray = this.rowColumnDirectives.toArray();
        refArray.forEach((/**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            columnMap.set(val.rowColumn, val);
        }));
        this.rowColumnTemplates = columnMap;
    };
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.getPageSizeOptions = /**
     * @return {?}
     */
    function () {
        return [5, 10, 20, 50, 100, 250];
    };
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.getDefaultPageSize = /**
     * @return {?}
     */
    function () {
        return 250;
    };
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.add = /**
     * @return {?}
     */
    function () {
        if (this.addRoute) {
            if (this.addRoute.queryParams) {
                this.router.navigate([this.addRoute.path], { queryParams: this.addRoute.queryParams });
            }
            else {
                this.router.navigate([this.addRoute.path]);
            }
        }
        else {
            this.router.navigate(['0'], { relativeTo: this.activatedRoute });
        }
    };
    /**
     * @param {?} row
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.onRowClick = /**
     * @param {?} row
     * @return {?}
     */
    function (row) {
        this.tableRowClick.emit(row);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.reload = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        this.tableLayoutInput.dataSource.filterSubject.next(filter);
        return false;
    };
    /**
     * @return {?}
     */
    TableContentResponsiveComponent.prototype.navigateBack = /**
     * @return {?}
     */
    function () {
        this.location.back();
    };
    TableContentResponsiveComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-table-content-responsive',
                    template: "<!-- =================================  Table search + dynamic filter comp + buttons =============================== -->\n<mat-toolbar style=\"height:90px\" class=\"table-layout-toolbar\" *ngIf=\"hasToolbar\">\n\n  <button mat-mini-fab name=\"cmd\" type=\"button\" [routerLink]=\"'..'\" class=\"margin-right--small\" *ngIf=\"hasBackButton\">\n    <mat-icon>arrow_back</mat-icon>\n  </button>\n\n  <ng-container><!-- <ng-container *permissionEdit=\"tableLayoutInput.expectedRoles\">-->\n    <button *ngIf=\"!tableLayoutInput.disableAddButton && hasAddButton\" mat-mini-fab name=\"cmd\" type=\"button\"\n            value=\"create\" (click)=\"add()\" class=\"margin-right--small\">\n      <mat-icon>add</mat-icon>\n    </button>\n  </ng-container>\n\n  <!-- TODO fix the excel export; probably those controls should be injectable via template/ngcontent -->\n<!--  <button *ngIf=\"tableLayoutInput.downloadable\" mat-mini-fab name=\"excel\" type=\"button\"\n          (click)=\"tableLayoutInput.dataSource.excelExport()\" class=\"margin-right&#45;&#45;small\">\n    <mat-icon>cloud_download</mat-icon>\n  </button>-->\n\n<!--  <table-search [searchFields]=\"tableLayoutInput.advanceSearchCriteria\"\n                [hasAdvanceSearch]=\"tableLayoutInput.advanceSearch\" *ngIf=\"tableLayoutInput.searchable && hasSearch\"\n                (changed)=\"reload($event)\"\n                class=\"margin-right&#45;&#45;small\"></table-search>-->\n\n  <div class=\"spacer\"></div>\n\n\n</mat-toolbar>\n\n<!-- =================================   Further table controls (e.g. tabs)========================================= -->\n\n<ng-content select=\"[controls]\"></ng-content>\n\n<!-- =================================   Paginator ================================================================= -->\n<div>\n  <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"getDefaultPageSize()\" [pageSizeOptions]=\"getPageSizeOptions()\">\n  </mat-paginator>\n</div>\n\n<!-- =================================== Mat Table ================================================================= -->\n<div class=\"base-table-responsive\">\n  <mat-table multiTemplateDataRows [dataSource]=\"tableLayoutInput.dataSource\" matSort\n             matSortActive=\"{{tableLayoutInput.matSortActive}}\" matSortDisableClear\n             matSortDirection=\"{{tableLayoutInput.matSortDirection ? tableLayoutInput.matSortDirection : 'desc'}}\"\n             class=\"expandable\">\n\n    <ng-container *ngFor=\"let column of displayedColumns;let i = index\" [matColumnDef]=\"column\">\n\n      <mat-header-cell *matHeaderCellDef mat-sort-header>\n        {{columnNames[i]}}\n      </mat-header-cell>\n      <mat-cell *matCellDef=\"let row\">\n        <span class=\"resp-row-label\" style=\"float:left; padding:0;\">{{columnNames[i]}}</span>\n        <ng-container [ngTemplateOutlet]=\"rowColumnTemplates.get(column)?.templateRef\"\n                      [ngTemplateOutletContext]=\"{$implicit: row}\"></ng-container>\n      </mat-cell>\n\n    </ng-container>\n\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onRowClick(row)\">\n    </mat-row>\n\n  </mat-table>\n</div>\n\n\n<!-- ===================================== Loading indicator ======================================================= -->\n<mat-card fxLayout=\"row\" *ngIf=\"tableLayoutInput.dataSource.status == 'loading'\" fxLayoutAlign=\"center\">\n<!-- TODO put loading indicator here  <app-loading-indicator></app-loading-indicator>-->\n</mat-card>\n\n\n\n",
                    animations: [
                        trigger('detailExpand', [
                            state('collapsed', style({ height: '0px', minHeight: '0', display: 'none' })),
                            state('expanded', style({ height: '*' })),
                            transition('expanded <=> collapsed', animate('225ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
                        ]),
                    ]
                }] }
    ];
    /** @nocollapse */
    TableContentResponsiveComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Location }
    ]; };
    TableContentResponsiveComponent.propDecorators = {
        tableLayoutInput: [{ type: Input }],
        rowColumnDirectives: [{ type: ContentChildren, args: [TableRowColumnDirective,] }],
        hasToolbar: [{ type: Input }],
        hasSearch: [{ type: Input }],
        hasAddButton: [{ type: Input }],
        hasBackButton: [{ type: Input }],
        hasPaginator: [{ type: Input }],
        tableRowClick: [{ type: Output }],
        matSort: [{ type: ViewChild, args: [MatSort, { static: true },] }],
        matPaginator: [{ type: ViewChild, args: [MatPaginator, { static: true },] }]
    };
    return TableContentResponsiveComponent;
}());
if (false) {
    /** @type {?} */
    TableContentResponsiveComponent.prototype._tableLayoutInput;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.expandedElement;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.rowColumnDirectives;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.rowColumnTemplates;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.hasToolbar;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.hasSearch;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.hasAddButton;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.hasBackButton;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.hasPaginator;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.tableRowClick;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.addRoute;
    /**
     * @type {?}
     * @private
     */
    TableContentResponsiveComponent.prototype.paginator;
    /**
     * @type {?}
     * @private
     */
    TableContentResponsiveComponent.prototype.sort;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.displayedColumns;
    /** @type {?} */
    TableContentResponsiveComponent.prototype.columnNames;
    /**
     * @type {?}
     * @private
     */
    TableContentResponsiveComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    TableContentResponsiveComponent.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    TableContentResponsiveComponent.prototype.location;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TableLayoutModule = /** @class */ (function () {
    function TableLayoutModule() {
    }
    TableLayoutModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        TableRowColumnDirective,
                        TableContentComponent,
                        TableTitleComponent,
                        TableHeaderComponent,
                        TableLayoutComponent,
                        TableContentResponsiveComponent
                    ],
                    imports: [
                        MatToolbarModule,
                        MatIconModule,
                        MatButtonModule,
                        CommonModule,
                        MatPaginatorModule,
                        MatTableModule,
                        MatSortModule,
                        MatCardModule,
                        MatFormFieldModule,
                        RouterModule,
                    ],
                    exports: [
                        TableRowColumnDirective,
                        TableContentComponent,
                        TableTitleComponent,
                        TableHeaderComponent,
                        TableLayoutComponent,
                        TableContentResponsiveComponent
                    ]
                },] }
    ];
    return TableLayoutModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LayoutModule = /** @class */ (function () {
    function LayoutModule() {
    }
    LayoutModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [LayoutComponent],
                    imports: [
                        TableLayoutModule
                    ],
                    exports: [
                        TableLayoutModule
                    ]
                },] }
    ];
    return LayoutModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { LayoutModule, LayoutComponent as ɵa, TableLayoutModule as ɵb, TableRowColumnDirective as ɵc, TableContentComponent as ɵd, TableTitleComponent as ɵe, TableHeaderComponent as ɵf, TableLayoutComponent as ɵg, TableContentResponsiveComponent as ɵh };
//# sourceMappingURL=yukawa-chain-base-angular-layout.js.map
